#![allow(deprecated)]
use std::fmt;
use std::str;
/// The display option for the time series plot. A CAROUSEL display option means that each plot grouping
/// is displayed one at a time, while a MULTIROW display option means that multiple plot groupings are displayed
/// simultaneously on different rows.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ComparisonTimeSeriesDisplayOption {
    #[serde(rename = "CAROUSEL")]
    Carousel,
    #[serde(rename = "MULTIROW")]
    Multirow,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ComparisonTimeSeriesDisplayOption {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ComparisonTimeSeriesDisplayOption::Carousel => "CAROUSEL",
            ComparisonTimeSeriesDisplayOption::Multirow => "MULTIROW",
            ComparisonTimeSeriesDisplayOption::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ComparisonTimeSeriesDisplayOption {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ComparisonTimeSeriesDisplayOption {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ComparisonTimeSeriesDisplayOption {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<
        ComparisonTimeSeriesDisplayOption,
        conjure_object::plain::ParseEnumError,
    > {
        match v {
            "CAROUSEL" => Ok(ComparisonTimeSeriesDisplayOption::Carousel),
            "MULTIROW" => Ok(ComparisonTimeSeriesDisplayOption::Multirow),
            v => {
                v.parse().map(|v| ComparisonTimeSeriesDisplayOption::Unknown(Unknown(v)))
            }
        }
    }
}
impl conjure_object::FromPlain for ComparisonTimeSeriesDisplayOption {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<
        ComparisonTimeSeriesDisplayOption,
        conjure_object::plain::ParseEnumError,
    > {
        v.parse()
    }
}
///An unknown variant of the ComparisonTimeSeriesDisplayOption enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
